--[[
local function setTintByPrototype(prototype,color)
	if prototype.pictures.layers ~= nil then
	
	log("layers aren't nil")
	log("starting to process prototype res.")
	
		for i,layer in pairs(prototype.pictures.layers) do
		
			if layer["hr_version"] then
			log("layer "..i.." with name "..prototype.name.." is being processed is in high res.")
				layer["hr_version"].tint = color
			end
			
			log("layer "..i.." with name "..prototype.name.." is being processed is in normal res.")
			layer.tint = color
		end
	else
		log("layers are nil")
		
		if prototype.pictures["hr_version"] then
			log("prototype "..i.." with name "..prototype.name.." is being processed is in high res.")
			prototype.pictures["hr_version"].tint = color		
		end
		
		log("prototype "..i.." with name "..prototype.name.." is being processed is in normal res.")
		prototype.pictures.tint = color	
	end
end

setTintByPrototype(data.raw["electric-pole"]["medium-electric-pole"],{0, 190, 190,})
--setTint(data.raw["generator"]["steam-engine"], {1, 0, 0})

local function TintPrototype(prototype,clr)
	
	for i,foundObject in pairs(prototype) do
		if foundObject.name == "hr_version" then
			log("found an hr_version names instance")
		else
		log("running recursively")
		c(foundObject)
		end
	end
end

local function TintLayers(source,color)
	for i,sprite in pairs(source) do
		if sprite.hr_version then
		log("hr")
		sprite.hr_version.tint = color
		else
		log("sd")
		sprite.tint = color
	end
end

local function TintSprite(sprite,color)
	sprite.tint = color
	sprite.hr_version.tint = color
end

TintSprite(data.raw["generator"]["steam-engine"]["horizonatal_animation"].layers[1],{0, 190, 190,})
TintLayers(data.raw["generator"]["steam-engine"]["horizonatal_animation"].layers,{0, 190, 190,})
TintPrototype(data.raw["generator"]["steam-engine"],{0, 190, 190,})

]]

--[[

local function search(depth)
	log("looking in depth "..depth.." m")
	if depth >= 30 then
	log("enough search!")
	else
	log("getting deeper from depth "..depth.." m")
	search(depth+10)
	log("gettig up to "..depth.." m")
	end
end

search(0)


]]


local function setTint(sprite, tint)
-- sprites have a similar general structure, be it a plain sprite, a rotated sprite or an animation
-- we know this structure and can start working on setting its tint right away
	if sprite.layers then
		for i,layer in pairs(sprite.layers) do
			setTint(layer,tint)
		end
	else
		if sprite.hr_version then
		setTint(sprite.hr_version,tint)
		end
		log(serpent.block(sprite))
		sprite.tint = tint
	end
end

local function solveWorldPoints(spriteTable,tint)
	for i,sprite in pairs(spriteTable) do
		setTint(sprite,tint)
	end
end

local function dePipeIfy(pipe_covers,tint)
	for i,v in pairs(pipe_covers) do
		setTint(v,tint)
	end
end

setTint(data.raw["electric-pole"]["small-electric-pole"].pictures, {50, 255, 50})
setTint(data.raw["electric-pole"]["medium-electric-pole"].pictures, {50, 255, 50})
setTint(data.raw["electric-pole"]["big-electric-pole"].pictures, {50, 255, 50})
setTint(data.raw["generator"]["steam-engine"].horizontal_animation, {255, 50, 50})
setTint(data.raw["generator"]["steam-engine"].vertical_animation, {255, 50, 50})
solveWorldPoints(data.raw["offshore-pump"]["offshore-pump"].graphics_set.animation, {255, 50, 50})
solveWorldPoints(data.raw["boiler"]["boiler"].structure, {255, 50, 50})
--pipe_covers
dePipeIfy(data.raw["generator"]["steam-engine"].fluid_box.pipe_covers, {50, 255, 50})
dePipeIfy(data.raw["boiler"]["boiler"].fluid_box.pipe_covers, {50, 255, 50})
dePipeIfy(data.raw["boiler"]["boiler"].output_fluid_box.pipe_covers, {50, 255, 50})
dePipeIfy(data.raw["offshore-pump"]["offshore-pump"].fluid_box.pipe_covers, {50, 255, 50})






























